unit MAIN;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, jpeg;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    Image1: TImage;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    passwordin:boolean;
    FClientInstance : TFarProc; 
     FPrevClientProc : TFarProc; 
     procedure ClientWndProc(var Message: TMessage);
    procedure CreateMDIChild(const Name: string);
    
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation


uses CHILDWIN, about, passdlg;

{$R *.dfm}

procedure TMainForm.ClientWndProc(var Message: TMessage); 
    var 
     Dc : hDC; 
     Row : Integer; 
     Col : Integer; 
     bmp: TBitmap; 
    begin 
     with Message do 
     case Msg of 
     WM_ERASEBKGND: 
     begin 
     Dc := TWMEraseBkGnd(Message).Dc; 
     bmp := TBitmap.Create; 
     bmp.Assign(Image1.Picture.Graphic); 
     for Row := 0 to ClientHeight div bmp.Height do 
     for Col := 0 to ClientWidth div bmp.Width do 
     BitBlt(Dc, 
     Col * bmp.Width, 
     Row * bmp.Height, 
     bmp.Width, 
     bmp.Height, 
     bmp.Canvas.Handle, 
     0, 
     0, 
     SRCCOPY); 
     Result := 1; 
     bmp.Free; 
     end; 
     else 
     Result := CallWindowProc(FPrevClientProc, 
     ClientHandle, 
     Msg, 
     wParam, 
     lParam); 
     end; 
    end;



procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
  if FileExists(Name) then Child.Memo1.Lines.LoadFromFile(Name);
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild(OpenDialog.FileName);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;
 {
procedure TMainForm.FormPaint(Sender: TObject);
var
   bn:integer;
begin
     if passwordin=false then
        begin
             passwordin:=true;
             bn:=passworddlg.showmodal;
             if bn=mrok then
                begin
                     if passworddlg.password.Text<>'123' then
                        //passworddlg.application.MessageBox('wrong','iiii',mb_ok+mb_iconinformation);
                        exit;
                end
             else
                 begin
                      close;
                 end;

        end;
end;
   }


procedure TMainForm.FormShow(Sender: TObject);
begin
     with Tpassworddlg.Create(Self) do
          begin
               try
                  if ShowModal <> mrok then
                     Application.Terminate;
               finally
                      Free;
               end;
          end;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
     FClientInstance := MakeObjectInstance(ClientWndProc); 
     FPrevClientProc := Pointer(GetWindowLong(ClientHandle,
     GWL_WNDPROC));
     SetWindowLong(ClientHandle, 
     GWL_WNDPROC, LongInt(FClientInstance));
end;

end.
